<?php

namespace Televox\Http\Controllers;

use Illuminate\Http\Request;

class reproducirArchivos extends Controller
{
    public function reproducir(Request $request, $id)
    {
        if (!$request->session()->get('descargar', false)) {
            abort(403, 'No tiene permisos para descargar grabaciones');
        } else {
            $datos = $request->validate([
                'archive' => 'boolean|bail|required',
            ]);

            $recording_log = 'recording_log';
            if (array_key_exists('archive', $datos) && $datos['archive'] != null && $datos['archive'] == true) {
                $recording_log = 'recording_log_archive';
            }

            switch (env('TIPO', 2)) {
                case 2:
                case 4:
                    $result = DB::connection('Dialvox')->table("$recording_log AS rl")->join('vicidial_list AS vl', 'rl.lead_id', '=', 'vl.lead_id')->where('rl.recording_id', '=', $id)->addSelect('rl.recording_id AS Nombre')->addSelect(DB::raw("date(rl.start_time) as 'FechaInicio'"))->addSelect(DB::raw("time(rl.start_time) AS 'HoraInicio'"))->addSelect(DB::raw("time(rl.end_time) AS 'HoraFin'"))->addSelect(DB::raw("sec_to_time(rl.length_in_sec) AS 'Duracion'"))->addSelect('rl.filename AS GRAB_ID')->addSelect('rl.user')->addSelect(DB::raw("substr(rl.location,Locate('MP3/',rl.location)+4) AS 'GRAB_FILE'"))->addSelect('rl.extension AS phone_number')->addSelect('rl.lead_id AS lead_id')->first();
                    if ($result) {
                        if (\is_dir(public_path('.') . '/audios')) {
                            mkdir(public_path('.') . '/audios');
                        }
                        if (!file_exists(\public_path('audios/' . $result->GRAB_ID . '.mp3'))) {
                            if (file_exists(\env('RUTAGRAB', '/mnt/Grabaciones') . DIRECTORY_SEPARATOR . "$result->GRAB_FILE")) {
                                copy(\env('RUTAGRAB', '/mnt/Grabaciones') . DIRECTORY_SEPARATOR . "$result->GRAB_FILE", public_path('audios') . DIRECTORY_SEPARATOR . $result->GRAB_ID . '.mp3');
                            } else {
                                if (file_exists(\env('RUTAGRAB', '/mnt/Grabaciones') . DIRECTORY_SEPARATOR . str_replace('-', '/', $result->FechaInicio) . '/' . str_replace(str_replace('-', '/', $result->FechaInicio) . '/', '', $result->GRAB_FILE))) {
                                    copy(\env('RUTAGRAB', '/mnt/Grabaciones') . DIRECTORY_SEPARATOR . str_replace('-', '/', $result->FechaInicio) . '/' . str_replace(str_replace('-', '/', $result->FechaInicio) . '/', '', $result->GRAB_FILE), public_path('audios') . DIRECTORY_SEPARATOR . $result->GRAB_ID . '.mp3');
                                } else {
                                    return ['Estado' => 'error', 'Descripcion' => 'No se logro encontrar la grabacion'];
                                }
                            }
                        }
                        if (\file_exists(\public_path('audios/' . $result->GRAB_ID . '.mp3'))) {
                            DB::connection('Televox')->table('tbl_log')->insertGetId(['ip' => $request->ip(), 'fecha' => date('Y-m-d H:i:s'), 'id_usuario' => $request->session()->get('id'), 'tipo' => 4, 'detalle' => 'El usuario ' . $request->session()->get('usuario') . " escucho la grabacion: $result->GRAB_ID Ext/Usuario: $result->user: Fecha: $result->FechaInicio Hora: $result->HoraInicio"]);
                            DB::connection('Televox')->table('audios_listen')->insert(['id_grab' => $result->GRAB_ID, 'id_usuario' => $request->session()->get('id')]);

                            return ['Estado' => 'ok', 'Nombre' => $result->GRAB_ID . '.mp3'];
                        } else {
                            return ['Estado' => 'error', 'Descripcion' => 'No se pudo reproducir la grabacion'];
                        }
                    } else {
                        return ['Estado' => 'error', 'Descripcion' => 'Grabacion no encontrada'];
                    }
                    break;
                case 3:
                    $result = DB::connection('Dialvox')->table('aurolog_grabaciones')->whereRaw('idGrabacion = ?', [$id])->addSelect('idGrabacion')->addSelect('ANI')->addSelect(BD::raw("CONCAT(DNIS,' ',digitos) as 'Destino'"))->addSelect(DB::raw("sec_to_time(hora) as 'horai'"))->addSelect(DB::raw("sec_to_time(hora+duracion) as 'horaf'"))->addSelect(DB::raw("sec_to_time(duracion) as 'duracion'"))->addSelect('extension')->addSelect(DB::raw("DATE_ADD('1900-01-01',INTERVAL dia-2 DAY) as 'fecha'"))->addSelect(DB::raw("substr(archivoVoz,Locate('/2',archivoVoz)+1) as 'GRAB_FILE'"))->addSelect(DB::raw("LEFT(substr(archivoVoz,Locate('/',archivoVoz,Locate('/',archivoVoz,Locate('/',archivoVoz,Locate('/2',archivoVoz)+1)+1)+1)+1),LENGTH(substr(archivoVoz,Locate('/',archivoVoz,Locate('/',archivoVoz,Locate('/',archivoVoz,Locate('/2',archivoVoz)+1)+1)+1)+1))-4) as 'GRAB_ID'"))->first();
                    if ($result) {
                        if (\is_dir(public_path('.') . '/audios')) {
                            mkdir(public_path('.') . '/audios');
                        }
                        if (!\file_exists(\public_path('audios/' . $result->GRAB_ID . '.mp3'))) {
                            if (file_exists(\env('RUTAGRAB', '/mnt/Grabaciones') . DIRECTORY_SEPARATOR . "$result->GRAB_FILE")) {
                                $encoding = new Settings\Encoding\Preset();
                                $encoding->setType(Settings\Encoding\Preset::TYPE_STANDARD);
                                $settings = new Settings\Settings($encoding);
                                $lame = new Lame('/usr/bin/lame', $settings);
                                try {
                                    $lame->encode(\env('RUTAGRAB', '/mnt/Grabaciones') . DIRECTORY_SEPARATOR . "$result->GRAB_FILE", public_path('audios') . DIRECTORY_SEPARATOR . $result->GRAB_ID . '.mp3');
                                } catch (RuntimeException $e) {
                                    return ['Estado' => 'error', 'Descripcion' => 'No se pudo convertir el audio<br>' . $e->getMessage()];
                                }
                            } else {
                                return ['Estado' => 'error', 'Descripcion' => 'No se logro encontrar la grabacion'];
                            }
                        }
                        if (\file_exists(\public_path('audios/' . $result->GRAB_ID . '.mp3'))) {
                            DB::connection('Televox')->table('tbl_log')->insertGetId(['ip' => $request->ip(), 'fecha' => date('Y-m-d H:i:s'), 'id_usuario' => $request->session()->get('id'), 'tipo' => 4, 'detalle' => 'El usuario ' . $request->session()->get('usuario') . " escucho la grabacion: $result->GRAB_ID Ext/Usuario: $result->extension: Fecha: $result->fecha Hora: $result->horai"]);
                            DB::connection('Televox')->table('audios_listen')->insert(['id_grab' => $result->GRAB_ID, 'id_usuario' => $request->session()->get('id')]);

                            return ['Estado' => 'ok', 'Nombre' => $result->GRAB_ID . '.mp3'];

                        } else {
                            return ['Estado' => 'error', 'Descripcion' => 'No se pudo reproducir la grabacion'];
                        }
                    } else {
                        return ['Estado' => 'error', 'Descripcion' => 'Grabacion no encontrada'];
                    }
                    break;
                case 1:
                    $result = DB::connection('Dialvox')->table('grab')->where('GRAB_ID', '=', $id)->addSelect(DB::raw("CONCAT(LEFT(GRAB_TIME_E,2),':',LEFT(RIGHT(GRAB_TIME_E,4),2),':',RIGHT(GRAB_TIME_E,2)) as 'GRAB_TIME_E'"))->addSelect(DB::raw("CONCAT(LEFT(GRAB_TIME_S,2),':',LEFT(RIGHT(GRAB_TIME_S,4),2),':',RIGHT(GRAB_TIME_S,2)) as 'GRAB_TIME_S'"))->addSelect(DB::raw("CONCAT(LEFT(GRAB_DATE,4),'/',LEFT(RIGHT(GRAB_DATE,4),2),'/',RIGHT(GRAB_DATE,2)) as 'GRAB_DATE'"))->addSelect('GRAB_FILE')->addSelect('GRAB_IP')->addSelect('GRAB_ID')->addSelect('GRAB_MACHINE')->addSelect('GRAB_EXT')->addSelect(DB::raw("TIME_FORMAT(SEC_TO_TIME(GRAB_DURATION),'%H:%i:%s') as 'GRAB_DURATION'"));
                    if ($result) {
                        if (\is_dir(public_path('.') . '/audios')) {
                            mkdir(public_path('.') . '/audios');
                        }
                        if (!\file_exists(\public_path('audios/' . $result->GRAB_ID . '.mp3'))) {
                            if (file_exists(\env('RUTAGRAB', '/mnt/Grabaciones') . DIRECTORY_SEPARATOR . "$result->GRAB_FILE")) {
                                $encoding = new Settings\Encoding\Preset();
                                $encoding->setType(Settings\Encoding\Preset::TYPE_STANDARD);
                                $settings = new Settings\Settings($encoding);
                                $lame = new Lame('/usr/bin/lame', $settings);
                                try {
                                    $lame->encode(\env('RUTAGRAB', '/mnt/Grabaciones') . DIRECTORY_SEPARATOR . "$result->GRAB_FILE", public_path('audios') . DIRECTORY_SEPARATOR . $result->GRAB_ID . '.mp3');
                                } catch (RuntimeException $e) {
                                    return ['Estado' => 'error', 'Descripcion' => 'No se pudo convertir el audio<br>' . $e->getMessage()];
                                }
                            } else {
                                return ['Estado' => 'error', 'Descripcion' => 'No se logro encontrar la grabacion '];
                            }
                        }
                        if (\file_exists(\public_path('audios/' . $result->GRAB_ID . '.mp3'))) {
                            DB::connection('Televox')->table('tbl_log')->insertGetId(['ip' => $request->ip(), 'fecha' => date('Y-m-d H:i:s'), 'id_usuario' => $request->session()->get('id'), 'tipo' => 4, 'detalle' => 'El usuario ' . $request->session()->get('usuario') . " escucho la grabacion: $result->GRAB_ID Ext/Usuario: $result->GRAB_EXT: Fecha: $result->GRAB_DATE Hora: $result->GRAB_TIME_S"]);
                            DB::connection('Televox')->table('audios_listen')->insert(['id_grab' => $result->GRAB_ID, 'id_usuario' => $request->session()->get('id')]);

                            return ['Estado' => 'ok', 'Nombre' => $result->GRAB_ID . '.mp3'];

                        } else {
                            return ['Estado' => 'error', 'Descripcion' => 'No se pudo reproducir la grabacion'];
                        }
                    } else {
                        abort(404, 'Grabacion no encontrada');
                    }
                    break;
            }
        }
    }
}
